【POJ 3311】 Hie with the Pie 状态压缩DP

Description

The Pizazz Pizzeria prides itself in delivering pizzas to its customers as fast as possible. Unfortunately, due to cutbacks, they can afford to hire only one driver to do the deliveries. He will wait for 1 or more (up to 10) orders to be processed before he starts any deliveries. Needless to say, he would like to take the shortest route in delivering these goodies and returning to the pizzeria, even if it means passing the same location(s) or the pizzeria more than once on the way. He has commissioned you to write a program to help him.

Input

Input will consist of multiple test cases. The first line will contain a single integer n indicating the number of orders to deliver, where 1 ≤ n ≤ 10. After this will be n + 1 lines each containing n + 1 integers indicating the times to travel between the pizzeria (numbered 0) and the n locations (numbers 1 to n). The jth value on the ith line indicates the time to go directly from location i to location j without visiting any other locations along the way. Note that there may be quicker ways to go from i to j via other locations, due to different speed limits, traffic lights, etc. Also, the time values may not be symmetric, i.e., the time to go directly from location i to j may not be the same as the time to go directly from location j to i. An input value of n = 0 will terminate input.

Output

For each test case, you should output a single number indicating the minimum time to deliver all of the pizzas and return to the pizzeria.

Sample Input

3
0 1 10 10
1 0 1 2
10 1 0 10
10 2 10 0
0

Sample Output

8

 

题目大意

题目的意思可以简化为:给定n个点(1 ≤ n ≤ 10),编号为 1~n,出发点为0,并给定这n+1个点之间的有向路长度。要求从0点出发,通过其余n个点后又回到原点,求最短路径长度。

 

分析

由于在寻找最短路径过程中,对于经过相同中间路径的不同路径会造成重复计算(例如0-1-2-3-4-5 和 0-1-2-3-7-8),因此可以使用动态规划避免重复计算。

我们定义 dp[s][v] 表示经过了 s 集合中的所有点后停在 v 点的最小花费,其中 s 的二进制第 i 位为1代表经过该点,为0代表没经过该点(因为1 ≤ n ≤ 10,所以使用一个 int 就足够压缩所有的状态)。

转移方程为:

  • dp[s][v] = min {dp[s][v], dp[s除去点v][u] + dis[u][v]}

 

AC代码

#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <queue>
#include <vector>
#include <algorithm>
#include <cmath>
#define ll long long
using namespace std;
const int INF = 0x3f3f3f3f;

const int N = 12;

int dis[N][N], dp[1 << N][N];



int main()
{
  int n;
  while(scanf("%d", &n))
  {
    if(!n)  break;
    for(int i = 0; i <= n; i++)
    {
      for(int j = 0; j <= n; j++)
      {
        scanf("%d", &dis[i][j]);
      }
    }
    
    for(int k = 0; k <= n; k++)
      for(int i = 0; i <= n; i++)  
        for(int j = 0; j <= n; j++)  
          if(dis[i][k] + dis[k][j] < dis[i][j])  dis[i][j] = dis[i][k] + dis[k][j];
    
    for(int s = 0; s < (1 << n); s++)
    {
      for(int i = 1; i <= n; i++)
      {
        if(s & (1 << (i - 1)))  //city i has been visited 
        {
          if(s == (1 << (i - 1)))  dp[s][i] = dis[0][i];
          else
          {
            dp[s][i] = INF;
            for(int j = 1; j <= n; j++)
            {
              if(j != i && s & (1 << (j - 1)))
              {
                dp[s][i] = min(dp[s][i], dp[s ^ (1 << (i - 1))][j] + dis[j][i]);
              }
            }
          }
        }
      }
    }
    
    int res = INF;
    for(int i = 1; i <= n; i++)
    {
      res = min(res, dp[(1 << n) - 1][i] + dis[i][0]);
    }
    printf("%d\n", res);

  }
  
  return 0;
}

 

  • 1
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给出一个$n\times m$的矩阵,每个位置上有一个非负整数,代表这个位置的海拔高度。一开始时,有一个人站在其中一个位置上。这个人可以向上、下、左、右四个方向移动,但是只能移动到海拔高度比当前位置低或者相等的位置上。一次移动只能移动一个单位长度。定义一个位置为“山顶”,当且仅当从这个位置开始移动,可以一直走到海拔高度比它低的位置上。请问,这个矩阵中最多有多少个“山顶”? 输入格式 第一行两个整数,分别表示$n$和$m$。 接下来$n$行,每行$m$个整数,表示整个矩阵。 输出格式 输出一个整数,表示最多有多少个“山顶”。 样例输入 4 4 3 2 1 4 2 3 4 3 5 6 7 8 4 5 6 7 样例输出 5 算法1 (递归dp) $O(nm)$ 对于这道题,我们可以使用递归DP来解决,用$f(i,j)$表示以$(i,j)$为起点的路径最大长度,那么最后的答案就是所有$f(i,j)$中的最大值。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码 算法2 (动态规划) $O(nm)$ 动态规划的思路与递归DP类似,只不过转移方程和实现方式有所不同。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值